# Linearly search for a query through a list. The query must exactly
# match the list items
def linear_search(query,alist):
    for i in range(len(alist)):
        if query == alist[i]:
            print("Found "+alist[i]+" at index "+str(i))
            return
    print("Not found")

# Some jazz albums in a list
albums = [
    "Kind of Blue - Miles Davis",
    "Saxophone Colossus - Sonny Rollins",
    "Time Out - Dave Brubeck",
    "Bitches Brew - Miles Davis",
    "Autumn Leaves - Cannonball Adderly",
    "Mercy, Mercy, Mercy - Cannonball Adderly",
    "Autumn Leaves - Bill Evans",
    "Now He Sings, Now He Sobs - Chick Corea",
    "Ellington at Newport 1956 - Duke Ellington",
    "Mingus Ah Um - Charles Mingus",
]

# Try using linear search to find albums
print("Using normal linear search")
linear_search("Mingus Ah Um - Charles Mingus",albums)
linear_search("Time Out - Dave Brubeck",albums)
linear_search("Moanin - Art Blakey",albums)
linear_search("Saxophone",albums)
linear_search("Autumn",albums)

print()

# Match album names based on the first 5 characters of the album
def linear_search_partial_match5(query,alist):
    for i in range(len(alist)):
        if query[0:5] == alist[i][0:5]:
            print("Found "+alist[i]+" at index "+str(i))
            return
    print("Not found")

# Try using partial matching during a linear search
print("Using partial matching")
linear_search_partial_match5("Mingus Ah Um - Charles Mingus",albums)
linear_search_partial_match5("Time Out - Dave Brubeck",albums)
linear_search_partial_match5("Moanin - Art Blakey",albums)
linear_search_partial_match5("Saxophone",albums)
linear_search("Autumn",albums)

print()

# Using albums ordered by artist would require a more sophisticated search
albmus_by_artist = [
    "Autumn Leaves - Cannonball Adderly",
    "Mercy, Mercy, Mercy - Cannonball Adderly",
    "Time Out - Dave Brubeck",
    "Now He Sings, Now He Sobs - Chick Corea",
    "Kind of Blue - Miles Davis",
    "Bitches Brew - Miles Davis",
    "Ellington at Newport 1956 - Duke Ellington",
    "Mingus Ah Um - Charles Mingus",
    "Saxophone Colossus - Sonny Rollins",
]
